/*
 * SplashManager.cpp
 *
 *  Created on: Mar 26, 2014
 *      Author: brian
 */

#include "SplashManager.h"
#include "Splash.h"

SplashManager* SplashManager::s_pInstance = 0;

SplashManager::SplashManager() {

}

SplashManager::~SplashManager() {

}

// add a splash to the collection
void SplashManager::addSplash(Splash * &aSplash) {
	m_splashes.push_back(aSplash);
}

void SplashManager::updateSplashes() {
	for (std::vector<Splash*>::iterator p_it = m_splashes.begin();
			p_it != m_splashes.end();) {
		if ((*p_it)->isDead()) {
			//cout << "The splash is dead" << endl;
			delete * p_it;
			p_it = m_splashes.erase(p_it);
		} else {
			// update the splash and go to
			// the next one!
			(*p_it)->update();
			++p_it;
		}
	}
}

void SplashManager::drawSplashes(SDL_Renderer* pRenderer) {
	for (std::vector<Splash*>::iterator p_it = m_splashes.begin();
			p_it != m_splashes.end();) {
		(*p_it)->draw(pRenderer);
		++p_it;
	}
}

void SplashManager::clearSplashes() {

}

