/*
 * SplashManager.h
 *
 *  Created on: Mar 26, 2014
 *      Author: brian
 */

#ifndef SPLASHMANAGER_H_
#define SPLASHMANAGER_H_

#include <memory>
#include "Splash.h"



class SplashManager
{
public:


    static SplashManager* Instance()
    {
        if(s_pInstance == 0)
        {
            s_pInstance = new SplashManager();
            return s_pInstance;
        }
        return s_pInstance;
    }

    // add a splash to the collection
    void addSplash(Splash *  &aSplash );


    void updateSplashes();
    void drawSplashes(SDL_Renderer* pRenderer);


    void clearSplashes();

    const std::vector<Splash*> getSplashes() { return m_splashes; }

private:
    static SplashManager* s_pInstance;
    SplashManager();
    ~SplashManager();


    SplashManager(const SplashManager&);
    SplashManager& operator=(const SplashManager&);

    // in play splashes
    std::vector<Splash*> m_splashes;

};

typedef SplashManager TheSplashManager;

#endif /* SPLASHMANAGER_H_ */
